% getCORESETPRB Get PRB associated with CORESET in a BWP
%
%   Note: This is an internal undocumented function and its API and/or
%   functionality may change in subsequent releases.

%   Copyright 2021 The MathWorks, Inc.

%#codegen

function coresetprb = getCORESETPRB(coreset,NStartBWP)

    % Expand the 6RBs in the CORESET
    fr = coreset.FrequencyResources~=0;
    allPRB = reshape(0:6*length(fr)-1,6,[]);
    prbIdx = reshape(allPRB(:,fr),[],1);

    if coreset.CORESETID ~= 0
        % Place FreqRes, relative to NStartBWP, at 6*ceil(NStartBWP/6)
        nStartBWP = double(NStartBWP);        
        nrb0 = 6*ceil(nStartBWP/6) - nStartBWP;
    else
        % For CORESET 0, the size of the BWP is assumed equal to the size
        % of the CORESET. As CORESET0 should fit in a BWP of the same size,
        % don't shift CORESET in BWP.
        nrb0 = 0;
    end

    coresetprb = nrb0 + prbIdx;
    
end

