classdef Formats14Common
    %Formats14Common Common configuration object for PUCCH formats 1 and 4
    %
    %   Note: This is an internal undocumented class and its API and/or
    %   functionality may change in subsequent releases.
    %
    %   Formats14Common properties (configurable):
    %
    %   OCCI - Orthogonal cover code index (default 0)

    %   Copyright 2021 The MathWorks, Inc.

    %#codegen

    % Public, tunable properties
    properties
        %OCCI Orthogonal cover code index
        %   Specify the orthogonal cover code index (OCCI) as a scalar
        %   nonnegative integer. The value must be in the range 0...6 for
        %   format 1 and in the range 0...3 for format 4. The default value
        %   is 0.
        OCCI = 0;
    end

    methods

        % Self-validate and set properties
        function obj = set.OCCI(obj,val)
            prop = 'OCCI';
            validateattributes(val, {'numeric'}, ...
                {'integer','scalar','nonnegative','<=',6}, ...
                [class(obj) '.' prop], prop);
            obj.(prop) = val;
        end

    end

end
