function [kRefTable,dmrsSCPattern,nDMRSSC] = ptrsSubcarrierInfo(dmrsType)
%ptrsSubcarrierInfo Provides the subcarrier related information for PT-RS
%
%   Note: This is an internal undocumented function and its API and/or
%   functionality may change in subsequent releases.
%
%   [KREFTABLE,DMRSSCPATTERN,NDMRSSC] = nr5g.internal.pxsch.ptrsSubcarrierInfo(DMRSTYPE)
%   returns the table of possible resource element offset for PTRS
%   KREFTABLE, the DM-RS subcarrier locations pattern in a resource block
%   DMRSSCPATTERN and the number of DM-RS subcarriers in a resource block,
%   according to the input DM-RS configuration type DMRSTYPE.

%   Copyright 2019 The MathWorks, Inc.

%#codegen

    if dmrsType == 1
        % Table 7.4.1.2.2-1/6.4.1.2.2.1-1, TS 38.211
        kRefTable = [0 2 6 8;...
                     2 4 8 10;...
                     1 3 7 9;...
                     3 5 9 11];
        % DM-RS subcarrier locations pattern per RB per port
        dmrsSCPattern = [0:2:10; 1:2:11];
        % Number of subcarriers carrying DM-RS symbols per RB per port
        nDMRSSC = 6;
    else
        % Table 7.4.1.2.2-1/6.4.1.2.2.1-1, TS 38.211
        kRefTable = [0 1 6 7;...
                     1 6 7 0;...
                     2 3 8 9;...
                     3 8 9 2;...
                     4 5 10 11;...
                     5 10 11 4];
        % DM-RS subcarrier locations pattern per RB per port
        dmrsSCPattern = [0 1 6 7; 2 3 8 9; 4 5 10 11];
        % Number of subcarriers carrying DM-RS symbols per RB per port
        nDMRSSC = 4;
    end

end
