classdef CodingCommon
    %CodingCommon Common wavegen configuration object for PUCCH formats 2,3,4
    %
    %   Note: This is an internal undocumented class and its API and/or
    %   functionality may change in subsequent releases.
    %
    %   CodingCommon properties (configurable):
    %
    %   Coding - Flag to enable channel coding (default true)

    %   Copyright 2021 The MathWorks, Inc.

    %#codegen

    % Public, tunable properties
    properties
        %Coding Flag to enable channel coding
        % Specify Coding as a scalar logical. Setting Coding to true
        % enables channel coding for the uplink control information (UCI).
        % The default is true.
        Coding = true;
    end

    methods
        % Self-validate and set properties
        function obj = set.Coding(obj,val)
            prop = 'Coding';
            validateattributes(val, {'logical', 'numeric'}, {'scalar', 'nonnan'}, ...
                [class(obj) '.' prop], prop);
            obj.(prop) = logical(val);
        end
    end
end
