%getCarrierCfgObject Recreate carrier configuration object from SCSCarrier or BWP parameters
%
%   Note: This is an internal undocumented function and its API and/or
%   functionality may change in subsequent releases.
%
%   Copyright 2021 The MathWorks, Inc.

%#codegen

function carrierCfg = getCarrierCfgObject(in, NCellID, cp)

    carrierCfg = nrCarrierConfig;
    carrierCfg.SubcarrierSpacing = in.SubcarrierSpacing;
    carrierCfg.NCellID = NCellID;
    if nargin == 3 % Input is a nrSCSCarrierConfig object
        carrierCfg.NSizeGrid = in.NSizeGrid;
        carrierCfg.NStartGrid = in.NStartGrid;
        carrierCfg.CyclicPrefix = cp;
    else % Input is a nrWavegenBWPConfig object
        carrierCfg.NSizeGrid = in.NSizeBWP;
        carrierCfg.NStartGrid = in.NStartBWP;
        carrierCfg.CyclicPrefix = in.CyclicPrefix;
    end
end