function numRB = getNumRB(fr, scs, bw)
% This is an internal function that can change any time. It serves a
% codegen-friendly functionality of getFR1/2BandwidthTable.

%   Copyright 2020 The MathWorks, Inc.

%#codegen

numRB = NaN;
if strcmp(fr, 'FR1')
   % BW MHz    5  10 15 20  25  30  40  50  60  80  90  100
    nrbtable = [25  52 79 106 133 160 216 270 NaN NaN NaN NaN;     % 15 kHz
                11  24 38 51  65  78  106 133 162 217 245 273;     % 30 kHz
                NaN 11 18 24  31  38  51  65  79  107 121 135];    % 60 kHz
    scsIdx = log2(scs/15)+1;
    bws = [5  10 15 20  25  30  40  50  60  80  90  100];
else
    % BW MHz    50 100 200 400
    nrbtable = [66  132 264 NaN;   % 60 kHz
                32  66  132 264];  % 120 kHz
    scsIdx = log2(scs/60)+1;
    bws = [50 100 200 400];
end

bwIdx = find(bws==bw, 1);
if ~isempty(bwIdx)
  numRB = nrbtable(scsIdx, bwIdx);
end


end

