classdef ConfigCommon 
    %ConfigCommon Base object for configuration objects, for simulation and
    % code generation
    %
    %   Note: This is an internal undocumented class and its API and/or
    %   functionality may change in subsequent releases.

    % Copyright 2019 The MathWorks, Inc.

    %#codegen

    methods 
      function v = set(obj, prop)
          % V = set(OBJ,PROP) provides the list of possible values V and
          % allows tab completion support with the values in V for a
          % property PROP of the object OBJ
        v = obj.([prop, '_Values']);
      end
    end

    methods (Access = protected)  
      % Validate and return a matching string from the enum property options
      function y = validateEnumProperties(obj, prop, value)
        options = set(obj, prop);
        y = validatestring(value, options, mfilename, prop);
      end

      function flag = isInactiveProperty(~, ~)
        flag = false;
      end

      function [flag, msg] = isUndefinedProperty(~, ~)
        flag = false;
        msg = '';
      end

    end

end
