function out = validatePDSCHModulation(fcnName,in,ncw)
% validatePDSCHModulation validates PDSCH modulation order or orders
%
%    Note: This is an internal undocumented function and its API and/or
%    functionality may change in subsequent releases.

%  Copyright 2018 The MathWorks, Inc.

%#codegen

    coder.internal.errorIf(~(ischar(in) || ...
        iscellstr(in) || isstring(in)) || isempty(in), ...
        'nr5g:nrPDSCH:InvalidModType');
    
    if (isstring(in))
        in = convertStringsToChars(in);
    end
    
    if (~iscell(in))
        temp = {in};
    else
        temp = in;
    end
    
    if (numel(temp)==1 && ncw==2)
        out = repmat(temp,1,2);
    else
        out = temp;
    end
    
    modlist = {'QPSK','16QAM','64QAM','256QAM'};
    
    for q = 1:numel(out)
        validatestring(out{q},modlist,fcnName,'modulation');
    end
    
end
