classdef nr5G_DL_InfoDialog < wirelessWaveformGenerator.nr5G_UL_InfoDialog
%

  %   Copyright 2019-2021 The MathWorks, Inc.
  
  properties (Dependent)
    Xoh_PDSCH
    PDSCHMappingType
  end
  
  properties (Hidden)
    Xoh_PDSCHType = 'text'
    Xoh_PDSCHLabel
    Xoh_PDSCHGUI
    PDSCHMappingTypeType = 'text'
    PDSCHMappingTypeLabel
    PDSCHMappingTypeGUI
  end
  
  methods
    function obj = nr5G_DL_InfoDialog(parent)
      obj@wirelessWaveformGenerator.nr5G_UL_InfoDialog(parent); % call base constructor

      setupDialog(obj); % layout controls
    end

    function props = displayOrder(~)
      props = {'SubcarrierSpacing'; 'AllocatedRBs'; 'Modulation'; 'TargetCodeRate'; ...
               'PayloadSize'; 'PDSCHMappingType'; 'AllocatedSymbols'; ...
               'DMRSConfigurationType'; 'DMRSAdditionalPosition'; 'DMRSTypeAPosition'; 'Xoh_PDSCH'; };
    end
    
    function restoreDefaults(obj)
      restoreDefaults@wirelessWaveformGenerator.nr5G_UL_InfoDialog(obj);
      obj.Xoh_PDSCH = '';
      obj.PDSCHMappingType = '';
    end
    
    function n = get.Xoh_PDSCH(obj) 
      n = evalin('base', obj.Xoh_PDSCHGUI.String);
    end

    function set.Xoh_PDSCH(obj, value) 
      obj.Xoh_PDSCHGUI.String = num2str(value);
    end
    
    function n = get.PDSCHMappingType(obj) 
      n = obj.PDSCHMappingTypeGUI.String;
    end

    function set.PDSCHMappingType(obj, value) 
      obj.PDSCHMappingTypeGUI.String = value;
    end

  end

end